;
;	>>> ASpongy <<< - by JAC! on 2013-03-30 
;
;	The compo filler I always wanted to release.
;
;	Finally party coded from the stuff I always started and never finished.
;	Done for Revision 2013 as part of the "Save the Wild Compo" project 
;	of MEGA and the BUndesMinisteriuM for the Scene  (BUMMS).
;
;	The original version requires extended disk or hard disk with at least 280k free space.
;	The original version requires 256k RAMBO memory expansion.
;
;	On 2013-11-15 I added a final version which runs better on real hardware.
;	It runs from a regular enhanced density disk with 119k free space and decrunches while loading.
;	It auto-detects any memory expansion with at least 256k.
;	It loops the animation and turns the background to red if your press a key while the animation is shown.



cnt	= $14
x1	= $80
p1	= $82
p2	= $84

banks		= $600

inflate_zp	= $80
inflate_source	= $8000
inflate_target	= $4000

logo_picture		= $8000
logo_picture.revision	= logo_picture
logo_picture.mega	= logo_picture+$1400

logo_lines	= $70

logo1_ftab1	= $a800		;Background
logo1_ftab2	= $a900		;Foreground
logo1_sm	= $ad00		;128 BPL Picture $2200 bytes

logo2_chroma	= $30
logo2_patch	= 5
logo2_ftab1	= $d800		;Background
;logo2_ftab2	= $d900		;Foreground
logo2_sm	= $dd00		;128 BPL Picture $2200 bytes

logo_sinh	= main.logo_sinus	;Sinus high
logo_sinl	= main.logo_sinus+$100	;Sinus low
logo_ctab	= $da00

hscrol	= $d404

	org $2000
	.proc loader
	lda $d40b
	bne loader
	sta $d400
	sta 559
	jsr check_ram
	lda #$ff
	sta $d301
	lda #0
	tax
clear_ram
	sta $4000,x
	inx
	bne clear_ram
	inc clear_ram+2
	bpl clear_ram
	
	lda #14
	sta 704
	sta $d012
	lda #1
	sta $d00d
	rts

	.proc check_ram
	sei
	ldx #0
	stx $d40e
	stx $d20e

isram1	stx $d301
	lda #$ff
	ldy $5000		;Locked_?_(Selftest)
	inc $5000
	iny
	cpy $5000
	beq isram2		;No.
	lda #$00		;Yes.
isram2	ldy $a000		;Locked_?_(BASIC)
	inc $a000
	iny
	cpy $a000
	beq isram3		;No.
	lda #$00		;Yes.
isram3	sta bankhlp,x
	stx $4000		;Store_#BANK
	inx
	bne isram1

	lda #$00
isram4	stx $d301
	cpx $4000		;#BANK_found_?
	beq isram5		;Yes.
	sta bankhlp,x		;No.
isram5	inx
	bne isram4

	ldy #0
	ldx #$00
isram7	lda bankhlp,x		;Sort_found_bankmax.
	beq isram8
	txa
	sta banks,y		;Store_bank.
	iny
isram8	inx
	bne isram7
	cpy #16			;Y_holds_number_of_banks.
	bcc no_ram		;No enough

	dey
	sty max_bank

	cpy #32
	bcs no_compyshop

	ldx #15			;Check if compyshop banks are present
check_compyshop
	lda compyshop_256k,x
	ldy max_bank 
check_compyshop1
	cmp banks,y
	beq check_compyshop2
	dey
	bpl check_compyshop1
	bmi no_compyshop
check_compyshop2
	dex
	bpl check_compyshop

	ldx #15
fix_compyshop
	lda compyshop_256k,x
	and #$cf		;Enable ANTIC access
	sta banks,x
	dex
	bpl fix_compyshop

no_compyshop
	lda #0
	sta banks+16		;End markers
	lda #$c0
	sta $d40e
	sta $d20e
	cli
	rts

no_ram	mwa #dl $d402
	mva #$22 $d400
	lda #0
	sta $d018
no_ram_loop
	inx
	stx $d017
	jmp no_ram_loop

max_bank .byte 0

	.local compyshop_256k
	.byte $23,$27,$2b,$2f,$63,$67,$6b,$6f,$a3,$a7,$ab,$af,$e3,$e7,$eb,$ef
	.endl

	.local dl
	.byte $70,$70,$70,$42,a(sm),$70,$02,$41,a(dl)
	.endl
	.local sm
	.byte "I know you would like to see ASpongy... "
	.byte "...but it requires 256K extended memory."
	.endl
	.endp

	.align $100
bankhlp	.ds $100

	.endp
	
	ini loader

;===============================================================

	org $2000
	.proc next_bank

bank_count
	ldx #0
	lda banks,x
	sta $d301
	inc bank_count+1
	txa
	asl
	cmp #16
	bcc *+4
	eor #31
	sta 712
	sta $d01a

	mwa #inflate_source inflate.inputPointer
	mwa #inflate_target inflate.outputPointer
	jsr inflate
	lda #$ff
	sta $d301
	rts
	.endp

	.proc inflate
	icl "ASpongy-Inflate.asm"
	icl "ASpongy-Inflate-Data.asm"
	.endp

	opt h-
	ins "ASpongy-Animation.bin"
	opt h+

;===============================================================


	org $6000
	.proc load_logos
	mwa #logo_picture_dfl inflate.inputPointer
	mwa #logo_picture inflate.outputPointer
	jmp inflate

	.local logo_picture_dfl
	ins "ASpongy-Logos.pic.dfl"
	.endl
	.endp

	ini load_logos

;===============================================================

	org $2000
	.proc main
	
	.local dl
	.byte $90
	.local logo1
top	.byte 0,0,0,0,0,0
lms	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
bottom	.byte 0,0,0,0,0,0
	.endl	;End of logo

	.local scroll
	.byte $52
lms	.word scroll_sm
	.byte $4f
	.word logo2_sm
	.endl

	.local logo2
top	.byte 0,0,0,0,0,0
lms	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
bottom	.byte 0,0,0,0,0,0
	.endl	;End of logo
	.byte $41
	.word dl
	.endl	;End of dl

	.align $100
	.local logo_sinus
	ins "ASpongy-Logo.sin"
	.endl

	.align $400
	.local font
	ins "ASpongy-AscII.chr"
	.endl

	.local scroll_sm
	.byte '             WHY A FUCKING ANIMATION?           '
	.byte 'AVDEV TEAM OF MEGA SPENT 3 DAMN MONTHS TO ENTER THE WILD COMPO AT REVISION.          '
	.byte 'WE REENGINIEERED AND CODED THE SHIT OUT OF THE ADVENTURE VISION.          '
	.byte 'THEN WE FOUND WE HAVE THE ONLY WILD ENTRY AND THERE WILL BE NO WILD          '
	.byte '...SO I WENT THE FUCK AND PARTY CODED A DEMO ABOUT IT TONGHT!          '
	.byte 'CODE BY JAC! / LOGO BY PREMIUM / MSX BY PG          '
	.byte 'HI TO RIBBON AND TBC WHO INSPIRED ME TO GO THE FUCK AND UNDERSTAND J/SPONGY, TO THE MEGA TEAM, SVOLLI AND ALL OHERS - SEE YOU AT SILLY VENTURE 2K13!         '
:4	.byte 'NOW VOTE THE FUCK FOR >CODE RED< ON ADVENTURE VISION! '
	.byte '.. OR VOTE FOR ASPONGY OF COURSE :-)      '
done
	.byte '                                                '
	.endl

	.proc start
	jsr init
	jsr spongy.init
	jsr spongy.effect
	jsr logo.init
	jmp *
	.endp
	
;----------------------------------------------------------------
	.proc nmi
	pha
	txa
	pha
	tya
	pha
	bit $d40f
	bpl vbi
dliv = *+1
	jsr return
	jmp exit

vbi	sta $d40f
vbiv	= *+1
	jsr return
	lda #$c0
	sta $d40e
	jsr sound.play
	inc cnt
	jmp exit

exit	pla
	tay
	pla
	tax
	pla
	rti

return	rts
	.end

	.proc init
	sei
	lda $d40b
	bne *-3
	sta $d400
	sta $d01a
	sta $d40e
	lda #$fe
	sta $d301

	ldx #<sound.module		;Low byte of RMT module to X reg
	ldy #>sound.module		;High byte of RMT module to Y reg
	lda #0				;Starting song line 0-255 to A reg
	jsr sound.init

	mwa #scroll_sm dl.scroll.lms
	lda $d40b
	bne *-3
	mwa #nmi $fffa
	lda #$40
	sta $d40e
	lda #1
	jsr wait
	lda #$c0
	sta $d40e
	rts
	.endp

	.proc wait
	clc
	adc cnt
loop	cmp cnt
	bne loop
	rts
	.endp

;===============================================================

	.proc logo
lcnt	.byte $8d,$d1		;Logo counter
xpos	.byte 0,83		;X move position
ypos	.byte 0,83		;Y move position
yact	.byte 0,0		;Y move position now
yflag	.byte 0,0		;Y move enable
soft	.byte 0,0		;HSCROL temporay
color1	.byte 0,0		;Color 1
color2	.byte 0,0		;Color 2
color3	.byte 0,0		;Color 2

	.proc init
	jsr init_lms
	jsr init_colors
	jsr init_sm
	
	mva #4 color1
	ora #logo2_chroma
	sta color1+1
	mva #8 color2
	ora #logo2_chroma
	sta color2+1
	mva #14 color3
	ora #logo2_chroma
	sta color3+1
	
	mwa #vbi main.nmi.vbiv
	mwa #dli nmi.dliv
	lda #$40
	sta $d40e
	rts

	.proc init_sm

	lda #0
	tay
loop_clear
	sta logo1_sm,y		;Clear sm begin
	sta logo1_sm+$2100,y
	sta logo2_sm,y		;Clear sm begin
	sta logo2_sm+$2100,y
	iny
	bne loop_clear

	mwa #logo_picture.revision p1	;Copy picture
	mwa #logo1_sm+24 p2
	jsr copy_logo
	mwa #logo_picture.mega p1	;Copy picture
	mwa #logo2_sm+24 p2
	jsr copy_logo
	rts
	.endp			;End of init_sm

	.proc init_lms
	.proc logo1
	ldx #0
	ldy #>logo1_sm
loop_lms
	tya			;Init LMS
	sta dl.logo1.lms+2,x
	sta dl.logo1.lms+5,x
	iny
	inx
	inx
	inx
	inx
	inx
	inx
	cpx #192		;64 Lines * 3
	bne loop_lms
	.endp
	.proc logo2
	ldx #0
	ldy #>logo2_sm
loop_lms
	tya			;Init LMS
	sta dl.logo2.lms+2,x
	sta dl.logo2.lms+5,x
	iny
	inx
	inx
	inx
	inx
	inx
	inx
	cpx #192		;64 Lines * 3
	bne loop_lms
	.endp
	.endp
	rts

	.proc copy_logo
	ldx #64			;Lines
loop_y
	ldy #127		;Bytes per line
	lda #0
loop_x1
	sta (p2),y
	dey
	cpy #79
	bne loop_x1
loop_x2
	lda (p1),y
	sta (p2),y
	dey
	bpl loop_x2
	adw p1 #80
	adw p2 #128
	dex
	bne loop_y
	rts
	.endp			;End of copy_logo_picture
	

	.proc init_colors
	
	ldx #0
loop_color
	txa
	clc
	adc #22
	and #63
	tay
	lda logo1_color,y
	sta logo1_ftab2,x
	txa
	lsr
	and #15
	cmp #8
	bcc *+4
	eor #15
	asl
	sta x1
	txa
	lsr
	and #$f0
	ora x1
	cpx #$80
	bcc *+4
	lda #0
	sta logo_ctab,x
	

	lda #0
	sta logo1_ftab1,x
	sta logo2_ftab1,x
	inx
	bne loop_color
	rts

	.local logo1_color
	color1 = $30
	color2 = $70
	.byte $0f,$0f,color1+$0f,$0f,color1+$0f,color1+$0f,color1+$0f,color1+$0f
	.byte color1+$0d,color1+$0f,color1+$0d,color1+$0d,color1+$0b,color1+$0d,color1+$0b,color1+$0b
	.byte color1+$09,color1+$0b,color1+$09,color1+$09,color1+$07,color1+$09,color1+$07,color1+$07
	.byte color1+$05,color1+$07,color1+$05,color1+$05,color1+$03,color1+$05,color1+$03,color1+$03

	.byte $0f,$0f,color2+$0f,$0f,color2+$0f,color2+$0f,color2+$0f,color2+$0f
	.byte color2+$0d,color2+$0f,color2+$0d,color2+$0d,color2+$0b,color2+$0d,color2+$0b,color2+$0b
	.byte color2+$09,color2+$0b,color2+$09,color2+$09,color2+$07,color2+$09,color2+$07,color2+$07
	.byte color2+$05,color2+$07,color2+$05,color2+$05,color2+$03,color2+$05,color2+$03,color2+$03
	.endl

	.endp		

	.endp			;End of init

;===============================================================

	.proc vbi
	lda #$3f
	sta $d400
	mwa #dl $d402
	lda #>font
	sta $d409
	lda #0
	sta $d01b
	jsr logo.effect.set_lms
	jsr scroll.effect
	lda cnt
	cmp #$ff
	bne no_5_secs

	lda scroll.flag
	bne scroll_flag_set
	inc scroll.flag
	jmp no_5_secs

scroll_flag_set
	lda logo.yflag
	cmp #2
	bcs logo1_yflag_set
	inc logo.yflag
	jmp no_5_secs

logo1_yflag_set
	lda logo.yflag+1
	cmp #2
	bcs logo2_yflag_set
	inc logo.yflag+1
	jmp no_5_secs

logo2_yflag_set

no_5_secs
	inc logo.xpos
	inc logo.xpos+1
	rts
	.endp

;===============================================================

	.proc dli
	lda #14
	sta $d40a
	sta $d01a
	jsr logo.effect.kernel
	lda #14
	sta $d40a
	sta $d01a
	lda #0
	sta $d40a
	sta $d01a
	rts
	.endp

;===============================================================

	.proc effect
	
	.proc set_lms
	
	.proc logo1
	ldx xpos
	lda logo_sinl,x
	eor #3
	sta soft
	lda logo_sinh,x
	.rept 33
	sta dl.logo1.lms+1+#*6	;Set_LMS_low_byte_even
	.endr
	eor #$80
	.rept 33
	sta dl.logo1.lms+4+#*6	;Set_LMS_low_byte_even
	.endr

	lda #$00
	sta dl.logo1.top		;Clear_DL
	sta dl.logo1.top+1
	sta dl.logo1.top+2
	sta dl.logo1.top+3
	sta dl.logo1.top+4
	sta dl.logo1.top+5

	lda ypos	;DL_Y_scroll
	asl
	clc
	adc ypos
	tax		;X=DL_Y_scroll*3
	lda yflag	;enabled?
	bne no_bounce
	ldx #0		;X=0
	jmp no_inc
no_bounce
	inc ypos
no_inc	lda logo_sinh,x
	lsr
	sta yact
	tay
	beq skip_all

	lda #0
	tax
	clc
loop_top
	adc #$10
	bpl no_overflow
	lda #$10
	inx
no_overflow
	sta dl.logo1.top,x
	dey
	bne loop_top

skip_all
	lda dl.logo1.top
	eor #$70
	sta dl.logo1.bottom
	lda dl.logo1.top+1
	eor #$70
	sta dl.logo1.bottom+1
	lda dl.logo1.top+2
	eor #$70
	sta dl.logo1.bottom+2
	lda dl.logo1.top+3
	eor #$70
	sta dl.logo1.bottom+3
	lda dl.logo1.top+4
	eor #$70
	sta dl.logo1.bottom+4
	lda dl.logo1.top+5
	eor #$70
	sta dl.logo1.bottom+5

	lda yflag
	cmp #2
	jne skip_flash
	lda lcnt
	sta x1
	ldx #0
flash	ldy x1

	.rept 15
	lda logo_ctab,y
	sta logo1_ftab1,x
	inx
	iny
	.endr
	inc x1
	inc x1
	inc x1
	cpx #logo_lines
	jcc flash
	inc logo.lcnt
skip_flash
	.endp		;End of logo1

	.proc logo2
	ldx xpos+1
	lda logo_sinl,x
	eor #3
	sta soft+1
	lda logo_sinh,x
	.rept 33
	sta dl.logo2.lms+1+#*6	;Set_LMS_low_byte_even
	.endr
	eor #$80
	.rept 33
	sta dl.logo2.lms+4+#*6	;Set_LMS_low_byte_even
	.endr

	lda #$00
	sta dl.logo2.top		;Clear_DL
	sta dl.logo2.top+1
	sta dl.logo2.top+2
	sta dl.logo2.top+3
	sta dl.logo2.top+4
	sta dl.logo2.top+5

	lda ypos+1		;DL_Y_scroll
	asl
	clc
	adc ypos+1
	tax		;X=DL_Y_scroll*3
	lda yflag+1	;enabled?
	bne no_bounce
	ldx #0		;X=0
	jmp no_inc
no_bounce
	inc ypos+1
no_inc
	lda logo_sinh,x
	lsr
	sta yact+1
	tay
	beq skip_all

	lda #0
	tax
	clc
loop_top
	adc #$10
	bpl no_overflow
	lda #$10
	inx
no_overflow
	sta dl.logo2.top,x
	dey
	bne loop_top

skip_all
	lda dl.logo2.top
	eor #$70
	sta dl.logo2.bottom
	lda dl.logo2.top+1
	eor #$70
	sta dl.logo2.bottom+1
	lda dl.logo2.top+2
	eor #$70
	sta dl.logo2.bottom+2
	lda dl.logo2.top+3
	eor #$70
	sta dl.logo2.bottom+3
	lda dl.logo2.top+4
	eor #$70
	sta dl.logo2.bottom+4
	lda dl.logo2.top+5
	eor #$70
	sta dl.logo2.bottom+5


	lda yflag+1
	cmp #2
	jne skip_flash
	lda lcnt+1
	clc
	adc #2
	sta x1
	ldx #0
flash	ldy x1

	.rept 15
	lda logo_ctab,y
	sta logo2_ftab1,x
	inx
	iny
	.endr
	inc x1
	inc x1
	inc x1
	cpx #logo_lines
	jcc flash
	dec logo.lcnt+1

skip_flash
	.endp		;End of logo2
	rts
	
	.endp		;End of set_lms

;===============================================================

	.proc kernel
	
	.proc logo1
	lda yact
	sta logo_adr
	lda soft
	sta hscrol
	lda color1
	sta $d016
	lda color2
	sta $d017
	ldx #logo_lines-1
loop
	lda logo1_ftab1,x
	ldy logo1_ftab2,x
logo_adr = *-2
	sta $d40a
	sta $d01a
	sty $d018
	dex
	bpl loop	;End of logo1
	.endp

	jsr scroll.kernel

	sta $d40a
	inc $fffc
	inc $fffc
	inc $fffc
	lda #14
	sta $d01a
	.proc logo2
	lda soft+1
	sta hscrol
	lda color1+1
	sta $d016
	lda color2+1
	sta $d017
	lda color3+1
	sta $d018
	ldx #logo_lines-1-logo2_patch
loop
	lda logo2_ftab1,x
logo_adr = *-2
	sta $d40a
	sta $d01a
	dex
	bpl loop	;End of logo2
	.endp


	rts
	.endp		;End of kernel

	.endp		;End of effect

	.endp		;End of logo

	.proc scroll

flag	.byte 0
xpos	.byte 0

	.proc effect
	lda flag
	beq skip
	lda cnt
	and #3
	eor #3
	sta xpos
	cmp #3
	bne skip
	inw dl.scroll.lms
	lda dl.scroll.lms
	cmp #<scroll_sm.done
	bne skip
	lda dl.scroll.lms+1
	cmp #>scroll_sm.done
	bne skip

	lda #0
	sta $d40a
	tax
kill	sta $d400,x
	sta $d200,x
	sta $d000,x
	inx
	bne kill

	ldx #5*50
wait_loop
wait1	lda $d40b
	bne wait1
wait2	lda $d40b
	bne wait2
	dex
	bne wait_loop
	jmp *

skip	rts
	.endp		;End of effect

	.proc kernel
:4	sta $d40a
	lda #14
	sta $d40a
	sta $d01a
	sta $d017
	lda xpos
	sta hscrol
	lda cnt
	and #$f0
	sta $d018
:8	sty $d40a
	rts
	.endp
	
	.endp		;End of scroll

	.endp		;End of main
	
;-----------------------------------------------------------------

STEREOMODE	equ 0				;0 => compile RMTplayer for mono 4 tracks
;						;1 => compile RMTplayer for stereo 8 tracks
;						;2 => compile RMTplayer for 4 tracks stereo L1 R2 R3 L4
;						;3 => compile RMTplayer for 4 tracks stereo L1 L2 R3 R4
;
;

	.proc sound
zp	= 203			;13 bytes of zero pages
init	= player		;Play 1 step
play	= player+3		;<A>=song number 0...255, <X>=lo byte of module, <Y>=hi byte of module
stop	= player+9	        ;All sounds off


	icl "RMT-Relocator.mac"		;Include relocator

	.align $100
	.ds $400
player
	icl "RMT-Player.asm"		;Include RMT player routine

	icl "ASpongy-PG-Features.asm"
module
	rmt_relocator 'ASpongy-PG.rmt' module
	.endp

;-----------------------------------------------------------------
	org $a800
	
	icl "ASpongy-Main.asm"

	run main.start
