package com.wudsn.productions.atari800.aspongy;


public final class ASpongy4Short extends ASpongy {

    private static final int BASE_SHIFT = 14;
    private static final int BASE = 1 << BASE_SHIFT;

    // private static final int BASE_SQRT = 128;
    // private static final int BASE_SQRT_SHIFT = BASE_SHIFT / 2;

    private short cos16(float a) {
	return (short) (Math.cos(a) * BASE);
    }

    private short mult16(short a, short b) {
	// long temp = (a >> BASE_SQRT_SHIFT) * (b >> BASE_SQRT_SHIFT);
	long temp = (a * b) >> BASE_SHIFT;
	return (short) temp;
    }

    @Override
    public void frame(float a, float b, int t, int[] imageData) {

	short acos, asin;
	short bcos, bsin;

	acos = cos16(a);
	asin = cos16(a + 8);

	bcos = cos16(b);
	bsin = cos16(b + 8);

	int imageIndex = 0;

	int XS, YS, ZS;
	XS = ((const64 << BASE_SHIFT) + 9 * cos16(a + b));
	YS = ((const64 << BASE_SHIFT) + 9 * cos16(b - a));
	ZS =  ((t & 127) << BASE_SHIFT); // Move through

	// println("t=" + t + " XS=" + XS / BASE + " YS=" + YS / BASE + " ZS="
	// + ZS / BASE);

	short ybsin = (short) -bsin; // y=-1;ybsin = y*bsin
	short ybcos = (short) -bcos; // y=-1;ybcos= y*bcos

	// println("ybsin=" + (ybsin * 1.0d) / BASE + " ybcos=" + (ybcos *
	// 1.0d)/ BASE);
	for (int y = 0; y < YSIZE; y++) {
	    int h = 0;

	    short u0, u, v, w;
	    u0 = (short) (-acos + asin);
	    w = (short) (acos + asin);

	    // println("u0=" + (u0 * 1.0d) / BASE + " w=" + (w * 1.0d) / BASE);

	    for (int x = 0; x < XSIZE; x++, imageData[imageIndex++] = h << 1) {
		v = (short) (ybcos - mult16(u0, bsin));
		u = (short) (mult16(u0, bcos) + ybsin);

		h = B127;

		int X, Y, Z;
		X = XS;
		Y = YS;
		Z = ZS;

//		System.out.println("X="+Integer.toHexString(X) +" Y="+Integer.toHexString(Y)+" Z="+Integer.toHexString(Z)+" u="+Integer.toHexString(u)+" U="+Integer.toHexString(v));
		int m = 1;
		while (h > 0 && m < const64) {
		    int XM, YM, ZM;
		    XM = X;
		    YM = Y;
		    ZM = Z;

		    for (int i = 1; i < 5; i++) {
			int sum;
			sum = N[(XM >> BASE_SHIFT) & B127]
				+ N[(YM >> BASE_SHIFT) & B127]
				+ N[(ZM >> BASE_SHIFT) & B127];

			if (sum >= 2) {
			    break;
			}
			m = mfactors[i];
			XM = X * m;
			YM = Y * m;
			ZM = Z * m;

		    }
		    X += u;
		    Y += v;
		    Z += w;
		    h--;
		}

		u0 = (short) (u0 + (2 * acos / XSIZE));
		w = (short) (w - (2 * asin / XSIZE));
	    }

	    ybsin = (short) (ybsin + (2 * bsin / YSIZE));
	    ybcos = (short) (ybcos + (2 * bcos / YSIZE));
	}

    }
}
