package com.wudsn.productions.atari800.aspongy;


public final class ASpongyDouble extends ASpongy {
    
    private double cos(double a) {
	return Math.cos(a);
    }

    private int integer(double a) {
	return (int) a;
    }

    @Override
    public void frame(float  a, float b, int t, int[] imageData) {

	double C, S;
	double c, s;

	C = cos(a);
	S = cos(a + 8);

	c = cos(b);
	s = cos(b + 8);

	int i = 0;
	double y;
	double AX = 2.0d / XSIZE;
	double AY = 2.0d / YSIZE;

	double XS, YS, ZS;
	XS = const64 + 9 * cos(a + b);
	YS = const64 + 9 * cos(b - a);
	ZS = t; // Move through

	for (y = -1; y < 1; y += AY) {
	    double x;
	    int h = 0;

	    for (x = -1; x < 1; x += AX, imageData[i++] = h << 1) {
		double m;

		double X, Y, Z;
		X = XS;
		Y = YS;
		Z = ZS;

		double u, v, w;
		u = x * C + S;
		v = y * c - u * s;
		u = u * c + y * s;
		w = C - x * S;

		m = C;
		h = B127;

		for (; h > 0 && m < const64;) {
		    for (m = 1; N[integer(X * m) & B127]
			    + N[integer(Y * m) & B127]
			    + N[integer(Z * m) & B127] < 2
			    && m < const64; m *= 3) {

		    }
		    X += u;
		    Y += v;
		    Z += w;
		    h--;
		}
	    }
	}

    }

}
