package com.wudsn.productions.atari800.aspongy;


public final class ASpongyFloat extends ASpongy {

    private float cos(float a) {
	return (float) Math.cos(a);
    }

    private int integer(float a) {
	return (int) a;
    }

    @Override
    public void frame(float a, float b, int t, int[] imageData) {
	final float AX = 2.0f / XSIZE;
	final float AY = 2.0f / YSIZE;

	float acos, asin;
	float bcos, bsin;
	acos = cos(a);
	asin = cos(a + 8);

	bcos = cos(b);
	bsin = cos(b + 8);

	int imageIndex = 0;

	float XS, YS, ZS;
	XS = const64 + 9 * cos(a + b);
	YS = const64 + 9 * cos(b - a);
	ZS = t & 127; // Move through

	// println("t=" + t + " XS=" + (int) XS + " YS=" + (int) YS + " ZS="
	// + (int) ZS);

	float ybsin = (-1) * bsin;
	float ybcos = (-1) * bcos;

	// println("ybsin=" + ybsin +" ybcos=" + ybcos);
	for (int y = 0; y < YSIZE; y++) {
	    int h = 0;

	    float u0, u, v, w;
	    u0 = (-1) * acos + asin;
	    w = acos - (-1) * asin;

	    // println("u0=" + u0 + " w=" + w);

	    for (int x = 0; x < XSIZE; x++, imageData[imageIndex++] = h << 1) {
		v = ybcos - u0 * bsin;
		u = u0 * bcos + ybsin;

		h = B127;

		float X, Y, Z;
		X = XS;
		Y = YS;
		Z = ZS;

		int m = 0;
		while (h > 0 && m < const64) {
		    float XM, YM, ZM;
		    XM = X;
		    YM = Y;
		    ZM = Z;
		    for (int i = 1; i < 5; i++) {
			int sum;
			sum = N[integer(XM) & B127] + N[integer(YM) & B127]
				+ N[integer(ZM) & B127];
			if (sum >= 2) {
			    break;
			}
			m = mfactors[i];
			XM = X * m;
			YM = Y * m;
			ZM = Z * m;

		    }
		    X += u;
		    Y += v;
		    Z += w;
		    h--;
		}
		u0 = u0 + (acos * AX);
		w = w - (asin * AX);
	    }

	    // System.out.println("y*bsin="+y*bsin+" ybsin="+ybsin+" delta="+(y*bsin-ybsin));
	    ybsin = ybsin + (bsin * AY);
	    ybcos = ybcos + (bcos * AY);
	}
    }
}
